| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | List of all members
Ogre::GLES2RenderBuffer Class Reference

Renderbuffer surface. More...

`#include <OgreGLES2HardwarePixelBuffer.h>`

Inheritance diagram for Ogre::GLES2RenderBuffer:
[legend]

## Public Types
enum | LockOptions { HBL_NORMAL, HBL_DISCARD, HBL_READ_ONLY, HBL_NO_OVERWRITE, HBL_WRITE_ONLY }
| Locking options. More...
enum | Usage { HBU_STATIC = 1, HBU_DYNAMIC = 2, HBU_WRITE_ONLY = 4, HBU_DISCARDABLE = 8, HBU_STATIC_WRITE_ONLY = HBU_STATIC | HBU_WRITE_ONLY, HBU_DYNAMIC_WRITE_ONLY = HBU_DYNAMIC | HBU_WRITE_ONLY, HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = HBU_DYNAMIC_WRITE_ONLY | HBU_DISCARDABLE }
| Enums describing buffer usage; not mutually exclusive. More...

## Public Member Functions
| GLES2RenderBuffer (GLenum format, uint32 width, uint32 height, GLsizei numSamples)
virtual | ~GLES2RenderBuffer ()
virtual void | _updateFromShadow (void)
| Updates the real buffer from the shadow buffer, if required. More...
virtual void | bindToFramebuffer (uint32 attachment, uint32 zoffset)
| Bind surface to frame buffer. More...
virtual void | blit (const HardwarePixelBufferSharedPtr &src, const Box &srcBox, const Box &dstBox)
| Copies a box from another PixelBuffer to a region of the this PixelBuffer. More...
void | blit (const HardwarePixelBufferSharedPtr &src)
| Convenience function that blits the entire source pixel buffer to this buffer. More...
void | blitFromMemory (const PixelBox &src, const Box &dstBox)
| Copies a region from normal memory to a region of this pixelbuffer. More...
void | blitFromMemory (const PixelBox &src)
| Convenience function that blits a pixelbox from memory to the entire buffer. More...
void | blitToMemory (const Box &srcBox, const PixelBox &dst)
| Copies a region of this pixelbuffer to normal memory. More...
void | blitToMemory (const PixelBox &dst)
| Convenience function that blits this entire buffer to a pixelbox. More...
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one. More...
virtual void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one. More...
const PixelBox & | getCurrentLock ()
| Get the current locked region. More...
uint32 | getDepth () const
| Gets the depth of this buffer. More...
PixelFormat | getFormat () const
| Gets the native pixel format of this buffer. More...
uint32 | getGLFormat ()
uint32 | getHeight () const
| Gets the height of this buffer. More...
virtual RenderTexture * | getRenderTarget (size_t slice=0)
| Get a render target for this PixelBuffer, or a slice of it. More...
size_t | getSizeInBytes (void) const
| Returns the size of this buffer in bytes. More...
Usage | getUsage (void) const
| Returns the Usage flags with which this buffer was created. More...
uint32 | getWidth () const
| Gets the width of this buffer. More...
bool | hasShadowBuffer (void) const
| Returns whether this buffer has a system memory shadow for quicker reading. More...
bool | isLocked (void) const
| Returns whether or not this buffer is currently locked. More...
bool | isSystemMemory (void) const
| Returns whether this buffer is held in system memory. More...
void * | lock (LockOptions options)
| Make every lock method from HardwareBuffer available. More...
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Make every lock method from HardwareBuffer available. More...
virtual const PixelBox & | lock (const Box &lockBox, LockOptions options)
| Lock the buffer for (potentially) reading / writing. More...
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Lock the buffer for (potentially) reading / writing. More...
void * | lock (LockOptions options)
virtual void | readData (size_t offset, size_t length, void *pDest)
| Reads data from the buffer and places it in the memory pointed to by pDest. More...
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes. More...
virtual void | unlock (void)
| Releases the lock on this buffer. More...
virtual void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough. More...

## Detailed Description

Renderbuffer surface.

Needs FBO extension.

## Member Enumeration Documentation

## ◆ Usage

enum Ogre::HardwareBuffer::Usage
| inherited

Enums describing buffer usage; not mutually exclusive.

Enumerator
HBU_STATIC | Static buffer which the application rarely modifies once created. Modifying the contents of this buffer will involve a performance hit.
HBU_DYNAMIC | Indicates the application would like to modify this buffer with the CPU fairly often. Buffers created with this flag will typically end up in AGP memory rather than video memory. This is the least optimal buffer setting.
HBU_WRITE_ONLY | Indicates the application will never read the contents of the buffer back, it will only ever write data. Locking a buffer with this flag will ALWAYS return a pointer to new, blank memory rather than the memory associated with the contents of the buffer; this avoids DMA stalls because you can write to a new memory area while the previous one is being used. However, you may read from it’s shadow buffer if you set one up
HBU_DISCARDABLE | Indicates that the application will be refilling the contents of the buffer regularly (not just updating, but generating the contents from scratch), and therefore does not mind if the contents of the buffer are lost somehow and need to be recreated. This allows and additional level of optimisation on the buffer. This option only really makes sense when combined with HBU_DYNAMIC_WRITE_ONLY.
HBU_STATIC_WRITE_ONLY | Combination of HBU_STATIC and HBU_WRITE_ONLY This is the optimal buffer usage setting.
HBU_DYNAMIC_WRITE_ONLY | Combination of HBU_DYNAMIC and HBU_WRITE_ONLY. If you use this, strongly consider using HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE instead if you update the entire contents of the buffer very regularly.
HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE | Combination of HBU_DYNAMIC, HBU_WRITE_ONLY and HBU_DISCARDABLE This means that you expect to replace the entire contents of the buffer on an extremely regular basis, most likely every frame. By selecting this option, you free the system up from having to be concerned about losing the existing contents of the buffer at any time, because if it does lose them, you will be replacing them next frame anyway. On some platforms this can make a significant performance difference, so you should try to use this whenever you have a buffer you need to update regularly. Note that if you create a buffer this way, you should use the HBL_DISCARD flag when locking the contents of it for writing.

## ◆ LockOptions

enum Ogre::HardwareBuffer::LockOptions
| inherited

Locking options.

Enumerator
HBL_NORMAL | Normal mode, ie allows read/write and contents are preserved. This kind of lock allows reading and writing from the buffer - it’s also the least optimal because basically you’re telling the card you could be doing anything at all. If you’re not using a shadow buffer, it requires the buffer to be transferred from the card and back again. If you’re using a shadow buffer the effect is minimal.
HBL_DISCARD | Discards the entire buffer while locking. This means you are happy for the card to discard the entire current contents of the buffer. Implicitly this means you are not going to read the data - it also means that the card can avoid any stalls if the buffer is currently being rendered from, because it will actually give you an entirely different one. Use this wherever possible when you are locking a buffer which was not created with a shadow buffer. If you are using a shadow buffer it matters less, although with a shadow buffer it’s preferable to lock the entire buffer at once, because that allows the shadow buffer to use HBL_DISCARD when it uploads the updated contents to the real buffer. Only allowed on buffers created with the HBU_DYNAMIC flag.
HBL_READ_ONLY | Lock the buffer for reading only. Not allowed in buffers which are created with HBU_WRITE_ONLY. Mandatory on static buffers, i.e. those created without the HBU_DYNAMIC flag.
HBL_NO_OVERWRITE | As HBL_DISCARD, except the application guarantees not to overwrite any region of the buffer which has already been used in this frame, can allow some optimisation on some APIs. This is only useful on buffers with no shadow buffer.
HBL_WRITE_ONLY | Lock the buffer for writing only.

## Constructor & Destructor Documentation

## ◆ GLES2RenderBuffer()

Ogre::GLES2RenderBuffer::GLES2RenderBuffer | ( | GLenum | format,
|  | uint32 | width,
|  | uint32 | height,
|  | GLsizei | numSamples
| ) |  |

## ◆ ~GLES2RenderBuffer()

virtual Ogre::GLES2RenderBuffer::~GLES2RenderBuffer | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ bindToFramebuffer()

virtual void Ogre::GLES2RenderBuffer::bindToFramebuffer | ( | uint32 | attachment,
|  | uint32 | zoffset
| ) |  |
| virtual

Bind surface to frame buffer.

Needs FBO extension.

Reimplemented from Ogre::GLHardwarePixelBufferCommon.

## ◆ blitFromMemory() [1/2]

void Ogre::GLES2HardwarePixelBuffer::blitFromMemory | ( | const PixelBox & | src,
|  | const Box & | dstBox
| ) |  |
| virtual inherited

Copies a region from normal memory to a region of this pixelbuffer.

The source image can be in any pixel format supported by OGRE, and in any size.

Parameters

  src | PixelBox containing the source pixels and format in memory
  dstBox | Box describing the destination region in this buffer

Remarks
  The source and destination regions dimensions don't have to match, in which case scaling is done. This scaling is generally done using a bilinear filter in hardware, but it is faster to pass the source image in the right dimensions.

Note
  Only call this function when the buffer is unlocked.

Implements Ogre::HardwarePixelBuffer.

Reimplemented in Ogre::GLES2TextureBuffer.

## ◆ blitFromMemory() [2/2]

void Ogre::HardwarePixelBuffer::blitFromMemory | ( | const PixelBox & | src | ) |
| inline inherited

Convenience function that blits a pixelbox from memory to the entire buffer.

The source image is scaled as needed.

Parameters

  src | PixelBox containing the source pixels and format in memory

Note
  Only call this function when the buffer is unlocked.

## ◆ blitToMemory() [1/2]

void Ogre::GLES2HardwarePixelBuffer::blitToMemory | ( | const Box & | srcBox,
|  | const PixelBox & | dst
| ) |  |
| virtual inherited

Copies a region of this pixelbuffer to normal memory.

Parameters

  srcBox | Box describing the source region of this buffer
  dst | PixelBox describing the destination pixels and format in memory

Remarks
  The source and destination regions don't have to match, in which case scaling is done.

Note
  Only call this function when the buffer is unlocked.

Implements Ogre::HardwarePixelBuffer.

## ◆ blitToMemory() [2/2]

void Ogre::HardwarePixelBuffer::blitToMemory | ( | const PixelBox & | dst | ) |
| inline inherited

Convenience function that blits this entire buffer to a pixelbox.

The image is scaled as needed.

Parameters

  dst | PixelBox describing the destination pixels and format in memory

Note
  Only call this function when the buffer is unlocked.

## ◆ getGLFormat()

uint32 Ogre::GLHardwarePixelBufferCommon::getGLFormat | ( |  | ) |
| inline inherited

## ◆ lock() [1/5]

virtual const PixelBox& Ogre::HardwarePixelBuffer::lock | ( | const Box & | lockBox,
|  | LockOptions | options
| ) |  |
| virtual inherited

Lock the buffer for (potentially) reading / writing.

Parameters

  lockBox | Region of the buffer to lock
  options | Locking options

Returns
  PixelBox containing the locked region, the pitches and the pixel format

## ◆ lock() [2/5]

virtual void* Ogre::HardwarePixelBuffer::lock | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options
| ) |  |
| virtual inherited

Lock the buffer for (potentially) reading / writing.

Parameters

  offset | The byte offset from the start of the buffer to lock
  length | The size of the area to lock, in bytes
  options | Locking options

Returns
  Pointer to the locked memory

Reimplemented from Ogre::HardwareBuffer.

## ◆ lock() [3/5]

virtual void* Ogre::HardwareBuffer::lock
| inline inherited

Make every lock method from HardwareBuffer available.

See http://www.research.att.com/~bs/bs_faq2.html#overloadderived

## ◆ lock() [4/5]

void* Ogre::HardwareBuffer::lock
| inline inherited

Make every lock method from HardwareBuffer available.

See http://www.research.att.com/~bs/bs_faq2.html#overloadderived

## ◆ lock() [5/5]

void* Ogre::HardwareBuffer::lock | ( | LockOptions | options | ) |
| inline inherited

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ getCurrentLock()

const PixelBox& Ogre::HardwarePixelBuffer::getCurrentLock | ( |  | ) |
| inherited

Get the current locked region.

This is the same value as returned by lock(const Box, LockOptions)

Returns
  PixelBox containing the locked region

## ◆ readData()

virtual void Ogre::HardwarePixelBuffer::readData | ( | size_t | offset,
|  | size_t | length,
|  | void * | pDest
| ) |  |
| virtual inherited

Reads data from the buffer and places it in the memory pointed to by pDest.

Parameters

  offset | The byte offset from the start of the buffer to read
  length | The size of the area to read, in bytes
  pDest | The area of memory in which to place the data, must be large enough to accommodate the data!

Implements Ogre::HardwareBuffer.

## ◆ writeData()

virtual void Ogre::HardwarePixelBuffer::writeData | ( | size_t | offset,
|  | size_t | length,
|  | const void * | pSource,
|  | bool | discardWholeBuffer = `false`
| ) |  |
| virtual inherited

Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

Parameters

  offset | The byte offset from the start of the buffer to start writing
  length | The size of the data to write to, in bytes
  pSource | The source of the data to be written
  discardWholeBuffer | If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can.

Implements Ogre::HardwareBuffer.

## ◆ blit() [1/2]

virtual void Ogre::HardwarePixelBuffer::blit | ( | const HardwarePixelBufferSharedPtr & | src,
|  | const Box & | srcBox,
|  | const Box & | dstBox
| ) |  |
| virtual inherited

Copies a box from another PixelBuffer to a region of the this PixelBuffer.

Parameters

  src | Source pixel buffer
  srcBox | Box describing the source region in src
  dstBox | Box describing the destination region in this buffer

Remarks
  The source and destination regions dimensions don't have to match, in which case scaling is done. This scaling is generally done using a bilinear filter in hardware, but it is faster to pass the source image in the right dimensions.

Note
  Only call this function when both buffers are unlocked.

Reimplemented in Ogre::D3D9HardwarePixelBuffer, Ogre::GLES2TextureBuffer, Ogre::D3D11HardwarePixelBuffer, Ogre::GLTextureBuffer, and Ogre::GL3PlusTextureBuffer.

## ◆ blit() [2/2]

void Ogre::HardwarePixelBuffer::blit | ( | const HardwarePixelBufferSharedPtr & | src | ) |
| inherited

Convenience function that blits the entire source pixel buffer to this buffer.

If source and destination dimensions don't match, scaling is done.

Parameters

  src | PixelBox containing the source pixels and format in memory

Note
  Only call this function when the buffer is unlocked.

## ◆ getRenderTarget()

virtual RenderTexture* Ogre::HardwarePixelBuffer::getRenderTarget | ( | size_t | slice = `0` | ) |
| virtual inherited

Get a render target for this PixelBuffer, or a slice of it.

The texture this was acquired from must have TU_RENDERTARGET set, otherwise it is possible to render to it and this method will throw an ERR_RENDERSYSTEM exception.

Parameters

  slice | Which slice

Returns
  A pointer to the render target. This pointer has the lifespan of this PixelBuffer.

Reimplemented in Ogre::D3D9HardwarePixelBuffer, Ogre::D3D11HardwarePixelBuffer, Ogre::GLES2TextureBuffer, Ogre::GLTextureBuffer, and Ogre::GL3PlusTextureBuffer.

## ◆ getWidth()

uint32 Ogre::HardwarePixelBuffer::getWidth | ( |  | ) | const
| inline inherited

Gets the width of this buffer.

## ◆ getHeight()

uint32 Ogre::HardwarePixelBuffer::getHeight | ( |  | ) | const
| inline inherited

Gets the height of this buffer.

## ◆ getDepth()

uint32 Ogre::HardwarePixelBuffer::getDepth | ( |  | ) | const
| inline inherited

Gets the depth of this buffer.

## ◆ getFormat()

PixelFormat Ogre::HardwarePixelBuffer::getFormat | ( |  | ) | const
| inline inherited

Gets the native pixel format of this buffer.

## ◆ unlock()

virtual void Ogre::HardwareBuffer::unlock | ( | void |  | ) |
| inline virtual inherited

Releases the lock on this buffer.

Remarks
  Locking and unlocking a buffer can, in some rare circumstances such as switching video modes whilst the buffer is locked, corrupt the contents of a buffer. This is pretty rare, but if it occurs, this method will throw an exception, meaning you must re-upload the data.

  Note that using the 'read' and 'write' forms of updating the buffer does not suffer from this problem, so if you want to be 100% sure your data will not be lost, use the 'read' and 'write' forms instead.

Reimplemented in Ogre::DefaultHardwareCounterBuffer, Ogre::DefaultHardwareUniformBuffer, Ogre::DefaultHardwareIndexBuffer, Ogre::DefaultHardwareVertexBuffer, Ogre::D3D11HardwareUniformBuffer, Ogre::D3D11HardwareVertexBuffer, and Ogre::D3D11HardwareIndexBuffer.

Referenced by Ogre::HardwareBuffer::copyData().

## ◆ copyData() [1/2]

virtual void Ogre::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer,
|  | size_t | srcOffset,
|  | size_t | dstOffset,
|  | size_t | length,
|  | bool | discardWholeBuffer = `false`
| ) |  |
| inline virtual inherited

Copy data from another buffer into this one.

Remarks
  Note that the source buffer must not be created with the usage HBU_WRITE_ONLY otherwise this will fail.

Parameters

  srcBuffer | The buffer from which to read the copied data
  srcOffset | Offset in the source buffer at which to start reading
  dstOffset | Offset in the destination buffer to start writing
  length | Length of the data to copy, in bytes.
  discardWholeBuffer | If true, will discard the entire contents of this buffer before copying

Reimplemented in Ogre::D3D11HardwareBuffer, Ogre::GLES2HardwareIndexBuffer, Ogre::GLES2HardwareVertexBuffer, Ogre::GL3PlusHardwareShaderStorageBuffer, Ogre::GL3PlusHardwareUniformBuffer, Ogre::GLES2HardwareUniformBuffer, Ogre::GL3PlusHardwareCounterBuffer, Ogre::GL3PlusHardwareVertexBuffer, Ogre::GL3PlusHardwareIndexBuffer, Ogre::D3D11HardwareUniformBuffer, Ogre::D3D11HardwareVertexBuffer, and Ogre::D3D11HardwareIndexBuffer.

References Ogre::HardwareBuffer::lock(), and Ogre::HardwareBuffer::unlock().

## ◆ copyData() [2/2]

virtual void Ogre::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer | ) |
| inline virtual inherited

Copy all data from another buffer into this one.

Remarks
  Normally these buffers should be of identical size, but if they're not, the routine will use the smallest of the two sizes.

References Ogre::HardwareBuffer::getSizeInBytes().

## ◆ _updateFromShadow()

virtual void Ogre::HardwareBuffer::_updateFromShadow | ( | void |  | ) |
| inline virtual inherited

Updates the real buffer from the shadow buffer, if required.

Reimplemented in Ogre::D3D11HardwareBuffer, Ogre::GLES2HardwareIndexBuffer, Ogre::GLES2HardwareVertexBuffer, Ogre::GL3PlusHardwareVertexBuffer, Ogre::GL3PlusHardwareIndexBuffer, Ogre::GLHardwareVertexBuffer, and Ogre::GLHardwareIndexBuffer.

## ◆ getSizeInBytes()

size_t Ogre::HardwareBuffer::getSizeInBytes | ( | void |  | ) | const
| inline inherited

Returns the size of this buffer in bytes.

Referenced by Ogre::HardwareBuffer::copyData().

## ◆ getUsage()

Usage Ogre::HardwareBuffer::getUsage | ( | void |  | ) | const
| inline inherited

Returns the Usage flags with which this buffer was created.

## ◆ isSystemMemory()

bool Ogre::HardwareBuffer::isSystemMemory | ( | void |  | ) | const
| inline inherited

Returns whether this buffer is held in system memory.

## ◆ hasShadowBuffer()

bool Ogre::HardwareBuffer::hasShadowBuffer | ( | void |  | ) | const
| inline inherited

Returns whether this buffer has a system memory shadow for quicker reading.

## ◆ isLocked()

bool Ogre::HardwareBuffer::isLocked | ( | void |  | ) | const
| inline inherited

Returns whether or not this buffer is currently locked.

## ◆ suppressHardwareUpdate()

void Ogre::HardwareBuffer::suppressHardwareUpdate | ( | bool | suppress | ) |
| inline inherited

Pass true to suppress hardware upload of shadow buffer changes.

The documentation for this class was generated from the following file:

- OgreGLES2HardwarePixelBuffer.h